@EChO OFF
title WinPE-Creator
echo WinPE-Creator
::Path to the ADK Installation.
Set adk_path=%programfiles(x86)%\Windows Kits\10\Assessment and Deployment Kit

::Place where files will be copied for builkding the WinPE.
Set winpe_root=%~dp0WinPE-Files

::Place where files will be copied to the root of the ISO.
Set rootfolders_path=%~dp0Root

::Folder with drivers for your ISO.
Set drivers_path=%~dp0Drivers

::User scripts location to include in new WinPE image. Scripts tree should include the modified startnet.cmd in which you can add your stuff
Set scripts_path=%~dp0Scripts

::Location of the Finall ISO. 
set ISO_Path=%~dp0WinPE-ISO

::Foldier with software to be added in the WinPE. 
set softwares_path=%~dp0Softwares
 
::Cleaning the foldier for building a new WinPE.
if exist %winpe_root% rd /q /s %winpe_root% 

echo Please entrer the name for the new WinPE ISO

set /p isoname= "ISO name: "

echo Preparing enviroment.
::Calling the ADK enviroment for building the ISO. 
call "%adk_path%\Deployment Tools\DandISetEnv.bat"

echo Will start to copying files.
::Coping the WinPE files.
call copype.cmd amd64 "%winpe_root%"

echo Mounting ISO.
::Mounting WinPE image.
Dism /Mount-Image /ImageFile:%winpe_root%\media\sources\boot.wim /index:1 /MountDir:%winpe_root%\mount
::pause
echo Adding package.
::Packages to be added to the WinPE ISO.
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-HTA.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-HTA_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-WMI.cab"
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-WMI_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-StorageWMI.cab"
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-StorageWMI_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-Scripting.cab"
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-Scripting_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-NetFx.cab"
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-NetFx_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-PowerShell.cab"
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-PowerShell_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-DismCmdlets.cab"
Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\en-us\WinPE-DismCmdlets_en-us.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-FMAPI.cab"

Dism /Add-Package /image:%winpe_root%\mount /PackagePath:"%adk_path%\Windows Preinstallation Environment\amd64\WinPE_OCs\WinPE-SecureBootCmdlets.cab"

echo Adding drivers.
::pause
::Adding drivers.
Dism /Add-Driver /image:%winpe_root%\mount /driver:%drivers_path% /recurse

Dism /Add-Driver /Image:"C:\winpe_amd64\mount" /Driver:"C:\path_to\drivers_to_add" /Recurse

echo Moving Softwares.
::Will copy scripts to the System32 folder of the WinPE.
xcopy %softwares_path%  "%winpe_root%\mount\Program Files\" /r /s /e /i /y

echo Moving Scripts.
::Will copy scripts to the System32 folder of the WinPE.
xcopy %scripts_path%  %winpe_root%\mount\Windows\System32 /r /s /e /i /y

::Set the region.
Dism /Set-AllIntl:en-US /Image:%winpe_root%\mount

::set the timezone. List of available timezones following the link http://technet.microsoft.com/en-US/library/cc749073(v=ws.10).aspx
Dism /image:%winpe_root%\mount /Set-TimeZone:"Mountain Standard Time"

echo Moving Folders to the Root of the drive.
::Will copy scripts to the System32 folder of the WinPE.
xcopy %rootfolders_path%  "%winpe_root%\mount\" /r /s /e /i /y

::Unmount
Dism /Unmount-Image /MountDir:%winpe_root%\mount\ /Commit

::pause
::Create the WinPE ISO.
MakeWinPEMedia /ISO %winpe_root% %ISO_Path%\%isoname%.iso
